Index: graphviz_digraph_parser.cpp
===================================================================
RCS file: /cvsroot/boost/boost/libs/graph/src/graphviz_digraph_parser.cpp,v
retrieving revision 1.10.4.2
retrieving revision 1.13
diff -u -r1.10.4.2 -r1.13
--- graphviz_digraph_parser.cpp	29 Oct 2004 12:44:12 -0000	1.10.4.2
+++ graphviz_digraph_parser.cpp	8 Feb 2005 14:52:28 -0000	1.13
@@ -1150,104 +841,139 @@
   /* First try to decide what to do without reference to lookahead token.  */
 
   yyn = yypact[yystate];
-  if (yyn == YYPACT_NINF)
+  if (yyn == YYFLAG)
     goto yydefault;
 
   /* Not known => get a lookahead token if don't already have one.  */
 
-  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
+  /* yychar is either YYEMPTY or YYEOF
+     or a valid token in external form.  */
+
   if (yychar == YYEMPTY)
     {
-      YYDPRINTF ((stderr, "Reading a token: "));
+#if YYDEBUG != 0
+      if (yydebug)
+	fprintf(stderr, "Reading a token: ");
+#endif
       yychar = YYLEX;
     }
 
-  if (yychar <= YYEOF)
+  /* Convert token to internal form (in yychar1) for indexing tables with */
+
+  if (yychar <= 0)		/* This means end of input. */
     {
-      yychar = yytoken = YYEOF;
-      YYDPRINTF ((stderr, "Now at end of input.\n"));
+      yychar1 = 0;
+      yychar = YYEOF;		/* Don't call YYLEX any more */
+
+#if YYDEBUG != 0
+      if (yydebug)
+	fprintf(stderr, "Now at end of input.\n");
+#endif
     }
   else
     {
-      yytoken = YYTRANSLATE (yychar);
-      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
+      yychar1 = YYTRANSLATE(yychar);
+
+#if YYDEBUG != 0
+      if (yydebug)
+	{
+	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
+	  /* Give the individual parser a way to print the precise meaning
+	     of a token, for further debugging info.  */
+#ifdef YYPRINT
+	  YYPRINT (stderr, yychar, yylval);
+#endif
+	  fprintf (stderr, ")\n");
+	}
+#endif
     }
 
-  /* If the proper action on seeing token YYTOKEN is to reduce or to
-     detect an error, take that action.  */
-  yyn += yytoken;
-  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
+  yyn += yychar1;
+  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
     goto yydefault;
+
   yyn = yytable[yyn];
-  if (yyn <= 0)
+
+  /* yyn is what to do for this token type in this state.
+     Negative => reduce, -yyn is rule number.
+     Positive => shift, yyn is new state.
+       New state is final state => don't bother to shift,
+       just return success.
+     0, or most negative number => error.  */
+
+  if (yyn < 0)
     {
-      if (yyn == 0 || yyn == YYTABLE_NINF)
-        goto yyerrlab;
+      if (yyn == YYFLAG)
+	goto yyerrlab;
       yyn = -yyn;
       goto yyreduce;
     }
+  else if (yyn == 0)
+    goto yyerrlab;
 
   if (yyn == YYFINAL)
     YYACCEPT;
 
   /* Shift the lookahead token.  */
-  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));
+
+#if YYDEBUG != 0
+  if (yydebug)
+    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
+#endif
 
   /* Discard the token being shifted unless it is eof.  */
   if (yychar != YYEOF)
     yychar = YYEMPTY;
 
   *++yyvsp = yylval;
+#ifdef YYLSP_NEEDED
+  *++yylsp = yylloc;
+#endif
 
-
-  /* Count tokens shifted since error; after three, turn off error
-     status.  */
-  if (yyerrstatus)
-    yyerrstatus--;
+  /* count tokens shifted since error; after three, turn off error status.  */
+  if (yyerrstatus) yyerrstatus--;
 
   yystate = yyn;
   goto yynewstate;
 
-
-/*-----------------------------------------------------------.
-| yydefault -- do the default action for the current state.  |
-`-----------------------------------------------------------*/
+/* Do the default action for the current state.  */
 yydefault:
+
   yyn = yydefact[yystate];
   if (yyn == 0)
     goto yyerrlab;
-  goto yyreduce;
 
-
-/*-----------------------------.
-| yyreduce -- Do a reduction.  |
-`-----------------------------*/
+/* Do a reduction.  yyn is the number of a rule to reduce with.  */
 yyreduce:
-  /* yyn is the number of a rule to reduce with.  */
   yylen = yyr2[yyn];
+  if (yylen > 0)
+    yyval = yyvsp[1-yylen]; /* implement default value of the action */
+
+#if YYDEBUG != 0
+  if (yydebug)
+    {
+      int i;
 
-  /* If YYLEN is nonzero, implement the default value of the action:
-     `$$ = $1'.
+      fprintf (stderr, "Reducing via rule %d (line %d), ",
+	       yyn, yyrline[yyn]);
 
-     Otherwise, the following line sets YYVAL to garbage.
-     This behavior is undocumented and Bison
-     users should not rely upon it.  Assigning to YYVAL
-     unconditionally makes the parser a bit smaller, and it avoids a
-     GCC warning that YYVAL may be used uninitialized.  */
-  yyval = yyvsp[1-yylen];
+      /* Print the symbols being reduced, and their result.  */
+      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
+	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
+      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
+    }
+#endif
 
 
-  YY_REDUCE_PRINT (yyn);
-  switch (yyn)
-    {
-        case 3:
-#line 257 "graphviz_parser.yy"
-    {yyval.i=0;;}
-    break;
+  switch (yyn) {
 
-  case 4:
-#line 261 "graphviz_parser.yy"
-    {
+case 2:
+#line 258 "graphviz_parser.yy"
+{yyval.i=0;;
+    break;}
+case 3:
+#line 262 "graphviz_parser.yy"
+{
     graphviz::vlist.clear();
     graphviz::attributes.clear();
     graphviz::subgraphs.clear();
@@ -1257,115 +983,104 @@
     graphviz::current_graph = static_cast<graphviz::Subgraph*>(g);
     graphviz::set_graph_name(*name);
     delete name;
-  ;}
-    break;
-
-  case 7:
-#line 277 "graphviz_parser.yy"
-    {yyval.ptr = yyvsp[0].ptr; ;}
-    break;
-
-  case 8:
-#line 277 "graphviz_parser.yy"
-    {yyval.ptr=(void*)(new std::string("G")); ;}
-    break;
-
-  case 15:
-#line 291 "graphviz_parser.yy"
-    { 
+  ;
+    break;}
+case 6:
+#line 278 "graphviz_parser.yy"
+{yyval.ptr = yyvsp[0].ptr; ;
+    break;}
+case 7:
+#line 278 "graphviz_parser.yy"
+{yyval.ptr=(void*)(new std::string("G")); ;
+    break;}
+case 14:
+#line 292 "graphviz_parser.yy"
+{ 
     graphviz::set_attribute(*graphviz::current_graph,
-                          graphviz::attribute_state); 
-  ;}
-    break;
-
-  case 16:
-#line 297 "graphviz_parser.yy"
-    { graphviz::attribute_state = GRAPH_GRAPH_A; ;}
-    break;
-
-  case 17:
+			  graphviz::attribute_state); 
+  ;
+    break;}
+case 15:
 #line 298 "graphviz_parser.yy"
-    { graphviz::attribute_state = GRAPH_NODE_A; ;}
-    break;
-
-  case 18:
+{ graphviz::attribute_state = GRAPH_GRAPH_A; ;
+    break;}
+case 16:
 #line 299 "graphviz_parser.yy"
-    { graphviz::attribute_state = GRAPH_EDGE_A; ;}
-    break;
-
-  case 21:
-#line 306 "graphviz_parser.yy"
-    { 
+{ graphviz::attribute_state = GRAPH_NODE_A; ;
+    break;}
+case 17:
+#line 300 "graphviz_parser.yy"
+{ graphviz::attribute_state = GRAPH_EDGE_A; ;
+    break;}
+case 19:
+#line 303 "graphviz_parser.yy"
+{;
+    break;}
+case 22:
+#line 310 "graphviz_parser.yy"
+{ 
     std::string* name  = static_cast<std::string*>(yyvsp[-2].ptr);
     std::string* value = static_cast<std::string*>(yyvsp[0].ptr);
     graphviz::attributes[*name] = *value; 
     delete name;
     delete value;
-  ;}
-    break;
-
-  case 28:
-#line 318 "graphviz_parser.yy"
-    { yyval.i = 0; ;}
-    break;
-
-  case 29:
+  ;
+    break;}
+case 29:
 #line 322 "graphviz_parser.yy"
-    { 
+{ yyval.i = 0; ;
+    break;}
+case 30:
+#line 326 "graphviz_parser.yy"
+{ 
     graphviz::set_attribute(
          *static_cast<graphviz::Subgraph*>(graphviz::current_graph),
-                            GRAPH_GRAPH_A);
-  ;}
-    break;
-
-  case 30:
-#line 330 "graphviz_parser.yy"
-    { 
+			    GRAPH_GRAPH_A);
+  ;
+    break;}
+case 31:
+#line 334 "graphviz_parser.yy"
+{ 
     graphviz::Vertex* temp   = static_cast<graphviz::Vertex*>(yyvsp[-1].ptr); 
     graphviz::current_vertex = *temp;
     graphviz::set_attribute(*static_cast<GRAPHVIZ_GRAPH*>(YYPARSE_PARAM),
-                            NODE_A); 
+			    NODE_A); 
     delete temp;
     yyval.i = 0;
-  ;}
-    break;
-
-  case 31:
-#line 340 "graphviz_parser.yy"
-    { yyval.i=0; ;}
-    break;
-
-  case 32:
-#line 340 "graphviz_parser.yy"
-    { yyval.i=0; ;}
-    break;
-
-  case 33:
+  ;
+    break;}
+case 32:
 #line 344 "graphviz_parser.yy"
-    {
+{ yyval.i=0; ;
+    break;}
+case 33:
+#line 344 "graphviz_parser.yy"
+{ yyval.i=0; ;
+    break;}
+case 34:
+#line 348 "graphviz_parser.yy"
+{
     std::string* name  = static_cast<std::string*>(yyvsp[0].ptr);
     std::pair<graphviz::Iter, bool> result = graphviz::lookup(*name); 
     if (result.second) {
       graphviz::current_vertex = result.first->second; 
       if (! graphviz::current_graph->is_root())
-        boost::add_vertex(graphviz::current_vertex, *graphviz::current_graph);
+	boost::add_vertex(graphviz::current_vertex, *graphviz::current_graph);
     } else
       graphviz::current_vertex = graphviz::add_name(*name, *static_cast<GRAPHVIZ_GRAPH*>(YYPARSE_PARAM)) ; 
     graphviz::Vertex* temp = new graphviz::Vertex(graphviz::current_vertex);
     yyval.ptr = (void *)temp;
     graphviz::attribute_state = NODE_A;  
     delete name;
-  ;}
-    break;
-
-  case 34:
-#line 358 "graphviz_parser.yy"
-    { yyval.ptr=yyvsp[0].ptr; ;}
-    break;
-
-  case 35:
+  ;
+    break;}
+case 35:
 #line 362 "graphviz_parser.yy"
-    {
+{ yyval.ptr=yyvsp[0].ptr; ;
+    break;}
+case 36:
+#line 366 "graphviz_parser.yy"
+{
     //consider port as a special properties ?? --need work here
     std::string* name = static_cast<std::string*>(yyvsp[-2].ptr);
     std::string* port = static_cast<std::string*>(yyvsp[0].ptr);
@@ -1380,38 +1095,37 @@
     graphviz::attribute_state = NODE_A;  
     delete name;
     delete port;
-  ;}
-    break;
-
-  case 36:
-#line 381 "graphviz_parser.yy"
-    {
+  ;
+    break;}
+case 37:
+#line 385 "graphviz_parser.yy"
+{
 
     typedef std::pair<void*, bool>* Ptr;
     Ptr source = static_cast<Ptr>(yyvsp[-2].ptr);
 
     for (std::vector<Ptr>::iterator it=graphviz::vlist.begin();
-         it !=graphviz::vlist.end(); ++it) { 
+	 it !=graphviz::vlist.end(); ++it) { 
       if ( source->second ) {
-        if ( (*it)->second )
-          graphviz::add_edges(static_cast<graphviz::Subgraph*>(source->first),
-                            static_cast<graphviz::Subgraph*>((*it)->first),
-                            *static_cast<GRAPHVIZ_GRAPH*>(YYPARSE_PARAM));
-        else
-          graphviz::add_edges(static_cast<graphviz::Subgraph*>(source->first),
-                            *static_cast<graphviz::Vertex*>((*it)->first),
-                            *static_cast<GRAPHVIZ_GRAPH*>(YYPARSE_PARAM));
+	if ( (*it)->second )
+	  graphviz::add_edges(static_cast<graphviz::Subgraph*>(source->first),
+			    static_cast<graphviz::Subgraph*>((*it)->first),
+			    *static_cast<GRAPHVIZ_GRAPH*>(YYPARSE_PARAM));
+	else
+	  graphviz::add_edges(static_cast<graphviz::Subgraph*>(source->first),
+			    *static_cast<graphviz::Vertex*>((*it)->first),
+			    *static_cast<GRAPHVIZ_GRAPH*>(YYPARSE_PARAM));
       } else {
-        graphviz::Vertex* temp = static_cast<graphviz::Vertex*>(source->first);
-        if ( (*it)->second )
-          graphviz::add_edges(*temp,
-                            static_cast<graphviz::Subgraph*>((*it)->first),
-                            *static_cast<GRAPHVIZ_GRAPH*>(YYPARSE_PARAM));
-        else
-          graphviz::add_edges(*temp,
-                            *static_cast<graphviz::Vertex*>((*it)->first),
-                            *static_cast<GRAPHVIZ_GRAPH*>(YYPARSE_PARAM));
-        delete temp;
+	graphviz::Vertex* temp = static_cast<graphviz::Vertex*>(source->first);
+	if ( (*it)->second )
+	  graphviz::add_edges(*temp,
+			    static_cast<graphviz::Subgraph*>((*it)->first),
+			    *static_cast<GRAPHVIZ_GRAPH*>(YYPARSE_PARAM));
+	else
+	  graphviz::add_edges(*temp,
+			    *static_cast<graphviz::Vertex*>((*it)->first),
+			    *static_cast<GRAPHVIZ_GRAPH*>(YYPARSE_PARAM));
+	delete temp;
       }
 
       delete source; 
@@ -1426,51 +1140,46 @@
 
     graphviz::attributes.clear();
     graphviz::vlist.clear(); 
-  ;}
-    break;
-
-  case 37:
-#line 426 "graphviz_parser.yy"
-    { graphviz::vlist.push_back(static_cast<std::pair<void*, bool>*>(yyvsp[0].ptr)); ;}
-    break;
-
-  case 40:
-#line 433 "graphviz_parser.yy"
-    { 
+  ;
+    break;}
+case 38:
+#line 430 "graphviz_parser.yy"
+{ graphviz::vlist.push_back(static_cast<std::pair<void*, bool>*>(yyvsp[0].ptr)); ;
+    break;}
+case 41:
+#line 437 "graphviz_parser.yy"
+{ 
     std::pair<void*, bool>* temp = new std::pair<void*, bool>;
     temp->first = yyvsp[0].ptr;
     temp->second = false;
     yyval.ptr = (void*)temp;
 
     graphviz::attribute_state = EDGE_A; 
-  ;}
-    break;
-
-  case 41:
-#line 442 "graphviz_parser.yy"
-    { 
+  ;
+    break;}
+case 42:
+#line 446 "graphviz_parser.yy"
+{ 
     std::pair<void*, bool>* temp = new std::pair<void*, bool>;
     temp->first = yyvsp[0].ptr;
     temp->second = true;
     yyval.ptr = (void*)temp;
 
     graphviz::attribute_state = EDGE_A; 
-  ;}
-    break;
-
-  case 42:
-#line 453 "graphviz_parser.yy"
-    {
+  ;
+    break;}
+case 43:
+#line 457 "graphviz_parser.yy"
+{
     if ( yyvsp[0].i )
       graphviz::current_graph = &graphviz::current_graph->parent();
     else
       graphviz::current_graph = graphviz::previous_graph;
-  ;}
-    break;
-
-  case 43:
-#line 460 "graphviz_parser.yy"
-    {
+  ;
+    break;}
+case 44:
+#line 464 "graphviz_parser.yy"
+{
     graphviz::previous_graph = graphviz::current_graph;
     std::string name = graphviz::random_string();
     graphviz::Subgraph* temp = graphviz::create_subgraph(name);
@@ -1478,19 +1187,17 @@
     graphviz::set_graph_name(name);
 
     yyval.ptr = (void *) graphviz::current_graph;
-  ;}
-    break;
-
-  case 44:
-#line 469 "graphviz_parser.yy"
-    {
+  ;
+    break;}
+case 45:
+#line 473 "graphviz_parser.yy"
+{
     graphviz::current_graph = &graphviz::current_graph->parent();
-  ;}
-    break;
-
-  case 45:
-#line 475 "graphviz_parser.yy"
-    {
+  ;
+    break;}
+case 46:
+#line 479 "graphviz_parser.yy"
+{
     //lookup ID_T if it is already in the subgraph,
     //if it is not, add a new subgraph
     std::string* name  = static_cast<std::string*>(yyvsp[0].ptr);
@@ -1507,218 +1214,239 @@
 
     yyval.ptr = (void *) graphviz::current_graph;
     delete name;
-  ;}
-    break;
-
-  case 46:
-#line 495 "graphviz_parser.yy"
-    {yyval.i = 1; ;}
-    break;
-
-  case 47:
-#line 495 "graphviz_parser.yy"
-    { yyval.i = 0; ;}
-    break;
-
-
-    }
-
-/* Line 999 of yacc.c.  */
-#line 1562 "graphviz_digraph_parser.cpp"
+  ;
+    break;}
+case 47:
+#line 499 "graphviz_parser.yy"
+{yyval.i = 1; ;
+    break;}
+case 48:
+#line 499 "graphviz_parser.yy"
+{ yyval.i = 0; ;
+    break;}
+}
+   /* the action file gets copied in in place of this dollarsign */
+#line 543 "/usr/share/bison.simple"
 
   yyvsp -= yylen;
   yyssp -= yylen;
+#ifdef YYLSP_NEEDED
+  yylsp -= yylen;
+#endif
 
-
-  YY_STACK_PRINT (yyss, yyssp);
+#if YYDEBUG != 0
+  if (yydebug)
+    {
+      short *ssp1 = yyss - 1;
+      fprintf (stderr, "state stack now");
+      while (ssp1 != yyssp)
+	fprintf (stderr, " %d", *++ssp1);
+      fprintf (stderr, "\n");
+    }
+#endif
 
   *++yyvsp = yyval;
 
+#ifdef YYLSP_NEEDED
+  yylsp++;
+  if (yylen == 0)
+    {
+      yylsp->first_line = yylloc.first_line;
+      yylsp->first_column = yylloc.first_column;
+      yylsp->last_line = (yylsp-1)->last_line;
+      yylsp->last_column = (yylsp-1)->last_column;
+      yylsp->text = 0;
+    }
+  else
+    {
+      yylsp->last_line = (yylsp+yylen-1)->last_line;
+      yylsp->last_column = (yylsp+yylen-1)->last_column;
+    }
+#endif
 
-  /* Now `shift' the result of the reduction.  Determine what state
-     that goes to, based on the state we popped back to and the rule
-     number reduced by.  */
+  /* Now "shift" the result of the reduction.
+     Determine what state that goes to,
+     based on the state we popped back to
+     and the rule number reduced by.  */
 
   yyn = yyr1[yyn];
 
-  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
-  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
+  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
+  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
     yystate = yytable[yystate];
   else
-    yystate = yydefgoto[yyn - YYNTOKENS];
+    yystate = yydefgoto[yyn - YYNTBASE];
 
   goto yynewstate;
 
+yyerrlab:   /* here on detecting error */
 
-/*------------------------------------.
-| yyerrlab -- here on detecting error |
-`------------------------------------*/
-yyerrlab:
-  /* If not already recovering from an error, report this error.  */
-  if (!yyerrstatus)
+  if (! yyerrstatus)
+    /* If not already recovering from an error, report this error.  */
     {
       ++yynerrs;
-#if YYERROR_VERBOSE
+
+#ifdef YYERROR_VERBOSE
       yyn = yypact[yystate];
 
-      if (YYPACT_NINF < yyn && yyn < YYLAST)
-        {
-          YYSIZE_T yysize = 0;
-          int yytype = YYTRANSLATE (yychar);
-          char *yymsg;
-          int yyx, yycount;
-
-          yycount = 0;
-          /* Start YYX at -YYN if negative to avoid negative indexes in
-             YYCHECK.  */
-          for (yyx = yyn < 0 ? -yyn : 0;
-               yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
-            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
-              yysize += yystrlen (yytname[yyx]) + 15, yycount++;
-          yysize += yystrlen ("syntax error, unexpected ") + 1;
-          yysize += yystrlen (yytname[yytype]);
-          yymsg = (char *) YYSTACK_ALLOC (yysize);
-          if (yymsg != 0)
-            {
-              char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
-              yyp = yystpcpy (yyp, yytname[yytype]);
-
-              if (yycount < 5)
-                {
-                  yycount = 0;
-                  for (yyx = yyn < 0 ? -yyn : 0;
-                       yyx < (int) (sizeof (yytname) / sizeof (char *));
-                       yyx++)
-                    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
-                      {
-                        const char *yyq = ! yycount ? ", expecting " : " or ";
-                        yyp = yystpcpy (yyp, yyq);
-                        yyp = yystpcpy (yyp, yytname[yyx]);
-                        yycount++;
-                      }
-                }
-              yyerror (yymsg);
-              YYSTACK_FREE (yymsg);
-            }
-          else
-            yyerror ("syntax error; also virtual memory exhausted");
-        }
+      if (yyn > YYFLAG && yyn < YYLAST)
+	{
+	  int size = 0;
+	  char *msg;
+	  int x, count;
+
+	  count = 0;
+	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
+	  for (x = (yyn < 0 ? -yyn : 0);
+	       x < (sizeof(yytname) / sizeof(char *)); x++)
+	    if (yycheck[x + yyn] == x)
+	      size += strlen(yytname[x]) + 15, count++;
+	  msg = (char *) malloc(size + 15);
+	  if (msg != 0)
+	    {
+	      strcpy(msg, "parse error");
+
+	      if (count < 5)
+		{
+		  count = 0;
+		  for (x = (yyn < 0 ? -yyn : 0);
+		       x < (sizeof(yytname) / sizeof(char *)); x++)
+		    if (yycheck[x + yyn] == x)
+		      {
+			strcat(msg, count == 0 ? ", expecting `" : " or `");
+			strcat(msg, yytname[x]);
+			strcat(msg, "'");
+			count++;
+		      }
+		}
+	      yyerror(msg);
+	      free(msg);
+	    }
+	  else
+	    yyerror ("parse error; also virtual memory exceeded");
+	}
       else
 #endif /* YYERROR_VERBOSE */
-        yyerror ("syntax error");
+	yyerror("parse error");
     }
 
-
+  goto yyerrlab1;
+yyerrlab1:   /* here on error raised explicitly by an action */
 
   if (yyerrstatus == 3)
     {
-      /* If just tried and failed to reuse lookahead token after an
-         error, discard it.  */
+      /* if just tried and failed to reuse lookahead token after an error, discard it.  */
 
-      /* Return failure if at end of input.  */
+      /* return failure if at end of input */
       if (yychar == YYEOF)
-        {
-          /* Pop the error token.  */
-          YYPOPSTACK;
-          /* Pop the rest of the stack.  */
-          while (yyss < yyssp)
-            {
-              YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
-              yydestruct (yystos[*yyssp], yyvsp);
-              YYPOPSTACK;
-            }
-          YYABORT;
-        }
+	YYABORT;
 
-      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
-      yydestruct (yytoken, &yylval);
-      yychar = YYEMPTY;
+#if YYDEBUG != 0
+      if (yydebug)
+	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
+#endif
 
+      yychar = YYEMPTY;
     }
 
-  /* Else will try to reuse lookahead token after shifting the error
-     token.  */
-  goto yyerrlab1;
+  /* Else will try to reuse lookahead token
+     after shifting the error token.  */
+
+  yyerrstatus = 3;		/* Each real token shifted decrements this */
 
+  goto yyerrhandle;
 
-/*----------------------------------------------------.
-| yyerrlab1 -- error raised explicitly by an action.  |
-`----------------------------------------------------*/
-yyerrlab1:
-  yyerrstatus = 3;      /* Each real token shifted decrements this.  */
+yyerrdefault:  /* current state does not do anything special for the error token. */
 
-  for (;;)
+#if 0
+  /* This is wrong; only states that explicitly want error tokens
+     should shift them.  */
+  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
+  if (yyn) goto yydefault;
+#endif
+
+yyerrpop:   /* pop the current state because it cannot handle the error token */
+
+  if (yyssp == yyss) YYABORT;
+  yyvsp--;
+  yystate = *--yyssp;
+#ifdef YYLSP_NEEDED
+  yylsp--;
+#endif
+
+#if YYDEBUG != 0
+  if (yydebug)
     {
-      yyn = yypact[yystate];
-      if (yyn != YYPACT_NINF)
-        {
-          yyn += YYTERROR;
-          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
-            {
-              yyn = yytable[yyn];
-              if (0 < yyn)
-                break;
-            }
-        }
-
-      /* Pop the current state because it cannot handle the error token.  */
-      if (yyssp == yyss)
-        YYABORT;
-
-      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
-      yydestruct (yystos[yystate], yyvsp);
-      yyvsp--;
-      yystate = *--yyssp;
+      short *ssp1 = yyss - 1;
+      fprintf (stderr, "Error: state stack now");
+      while (ssp1 != yyssp)
+	fprintf (stderr, " %d", *++ssp1);
+      fprintf (stderr, "\n");
+    }
+#endif
+
+yyerrhandle:
 
-      YY_STACK_PRINT (yyss, yyssp);
+  yyn = yypact[yystate];
+  if (yyn == YYFLAG)
+    goto yyerrdefault;
+
+  yyn += YYTERROR;
+  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
+    goto yyerrdefault;
+
+  yyn = yytable[yyn];
+  if (yyn < 0)
+    {
+      if (yyn == YYFLAG)
+	goto yyerrpop;
+      yyn = -yyn;
+      goto yyreduce;
     }
+  else if (yyn == 0)
+    goto yyerrpop;
 
   if (yyn == YYFINAL)
     YYACCEPT;
 
-  YYDPRINTF ((stderr, "Shifting error token, "));
+#if YYDEBUG != 0
+  if (yydebug)
+    fprintf(stderr, "Shifting error token, ");
+#endif
 
   *++yyvsp = yylval;
-
+#ifdef YYLSP_NEEDED
+  *++yylsp = yylloc;
+#endif
 
   yystate = yyn;
   goto yynewstate;
 
+ yyacceptlab:
+  /* YYACCEPT comes here.  */
+  if (yyfree_stacks)
+    {
+      free (yyss);
+      free (yyvs);
+#ifdef YYLSP_NEEDED
+      free (yyls);
+#endif
+    }
+  return 0;
 
-/*-------------------------------------.
-| yyacceptlab -- YYACCEPT comes here.  |
-`-------------------------------------*/
-yyacceptlab:
-  yyresult = 0;
-  goto yyreturn;
-
-/*-----------------------------------.
-| yyabortlab -- YYABORT comes here.  |
-`-----------------------------------*/
-yyabortlab:
-  yyresult = 1;
-  goto yyreturn;
-
-#ifndef yyoverflow
-/*----------------------------------------------.
-| yyoverflowlab -- parser overflow comes here.  |
-`----------------------------------------------*/
-yyoverflowlab:
-  yyerror ("parser stack overflow");
-  yyresult = 2;
-  /* Fall through.  */
-#endif
-
-yyreturn:
-#ifndef yyoverflow
-  if (yyss != yyssa)
-    YYSTACK_FREE (yyss);
+ yyabortlab:
+  /* YYABORT comes here.  */
+  if (yyfree_stacks)
+    {
+      free (yyss);
+      free (yyvs);
+#ifdef YYLSP_NEEDED
+      free (yyls);
 #endif
-  return yyresult;
+    }
+  return 1;
 }
-
-
-#line 497 "graphviz_parser.yy"
+#line 501 "graphviz_parser.yy"
 
 
 namespace boost {
@@ -1738,4 +1466,3 @@
     
 }
 
-
Index: graphviz_digraph_parser.hpp
===================================================================
RCS file: /cvsroot/boost/boost/libs/graph/src/graphviz_digraph_parser.hpp,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- graphviz_digraph_parser.hpp	26 Jan 2004 08:58:39 -0000	1.1
+++ graphviz_digraph_parser.hpp	8 Feb 2005 14:52:29 -0000	1.2
@@ -1,62 +1,8 @@
-/* A Bison parser, made by GNU Bison 1.875a.  */
-
-/* Skeleton parser for Yacc-like parsing with Bison,
-   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.
-
-   This program is free software; you can redistribute it and/or modify
-   it under the terms of the GNU General Public License as published by
-   the Free Software Foundation; either version 2, or (at your option)
-   any later version.
-
-   This program is distributed in the hope that it will be useful,
-   but WITHOUT ANY WARRANTY; without even the implied warranty of
-   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-   GNU General Public License for more details.
-
-   You should have received a copy of the GNU General Public License
-   along with this program; if not, write to the Free Software
-   Foundation, Inc., 59 Temple Place - Suite 330,
-   Boston, MA 02111-1307, USA.  */
-
-/* As a special exception, when this file is copied by Bison into a
-   Bison output file, you may use that output file without restriction.
-   This special exception was added by the Free Software Foundation
-   in version 1.24 of Bison.  */
-
-/* Tokens.  */
-#ifndef YYTOKENTYPE
-# define YYTOKENTYPE
-   /* Put the tokens into the symbol table, so that GDB and other debuggers
-      know about them.  */
-   enum yytokentype {
-     GRAPH_T = 258,
-     NODE_T = 259,
-     EDGE_T = 260,
-     DIGRAPH_T = 261,
-     EDGEOP_T = 262,
-     SUBGRAPH_T = 263,
-     ID_T = 264
-   };
-#endif
-#define GRAPH_T 258
-#define NODE_T 259
-#define EDGE_T 260
-#define DIGRAPH_T 261
-#define EDGEOP_T 262
-#define SUBGRAPH_T 263
-#define ID_T 264
-
-
-
-
-#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
-typedef int YYSTYPE;
-# define yystype YYSTYPE /* obsolescent; will be withdrawn */
-# define YYSTYPE_IS_DECLARED 1
-# define YYSTYPE_IS_TRIVIAL 1
-#endif
-
-
-
-
+#define	GRAPH_T	257
+#define	NODE_T	258
+#define	EDGE_T	259
+#define	DIGRAPH_T	260
+#define	EDGEOP_T	261
+#define	SUBGRAPH_T	262
+#define	ID_T	263
 
